flaskr/departments/models.py
from flaskr.extensions import db, ma


class DepartmentModel(db.Model):

    __tablename__ = 'department'

    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(20), unique=True, nullable=False)
    average_salary = db.Column(db.Float(precision=2), nullable=True)
    employees = db.relationship('EmployeeModel', backref='department')
    num_of_employees = 0

    def __init__(self, name, average_salary=0):
        self.name = name
        self.average_salary = average_salary
        self.num_of_employees = 0

    @classmethod
    def find_by_name(cls, name):
        return cls.query.filter_by(name=name).first()

    def save(self):
        db.session.add(self)
        db.session.commit()

    def remove(self):
        db.session.delete(self)
        db.session.commit()

    # average_salary_calculation
    def update_average_salary(self):
        total = 0
        for i in self.employees:
            total += float(i.salary)
        try:
            self.average_salary = round(total / len(self.employees), 2)
        except ZeroDivisionError:
            self.average_salary = 0

    def count_employees(self):
        self.num_of_employees = len(self.employees)


class DepartmentSchema(ma.Schema):
    """
    serializing class of Marshmallow
    """
    class Meta:
        fields = ('id', 'name', 'average_salary', 'num_of_employees')


department_schema = DepartmentSchema()
departments_schema = DepartmentSchema(many=True)

flaskr/employees/models.py
from marshmallow import fields

from flaskr.extensions import db, ma


class EmployeeModel(db.Model):

    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(30), nullable=False)
    dob = db.Column(db.DateTime, nullable=False)
    salary = db.Column(db.Float(precision=2), nullable=False)
    department_id = db.Column(db.Integer, db.ForeignKey('department.id'), nullable=True)

    def __init__(self, name, dob, salary, department_id=None):
        self.name = name
        self.dob = dob
        self.salary = salary
        self.department_id = department_id

    @classmethod
    def find_by_id(cls, _id):
        return cls.query.get_or_404(_id)

    @classmethod
    def check_identical(cls, name, dob, salary, department_id=None):
        return cls.query.filter_by(name=name, dob=dob, salary=salary, department_id=department_id).first()

    def save(self):
        db.session.add(self)
        db.session.commit()
        if self.department:
            self.department.update_average_salary()
            db.session.commit()

    def remove(self):
        db.session.delete(self)
        db.session.commit()


class EmployeeSchema(ma.Schema):
    dob = fields.DateTime('%Y-%m-%d')
    department_id = fields.Field(allow_none=True)

    class Meta:
        fields = ('id', 'name', 'dob', 'salary', 'department_id')


employee_schema = EmployeeSchema()
employees_schema = EmployeeSchema(many=True)

flaskr/departments/forms.py
from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField
from wtforms.validators import DataRequired


class DepartmentCreateForm(FlaskForm):
    name = StringField('Name', _name='name', validators=[DataRequired()])
    submit = SubmitField('Add')


class DepartmentEditForm(DepartmentCreateForm):
    submit = SubmitField('Edit')

flaskr/employees/forms.py
from datetime import datetime
from flask_wtf import FlaskForm
from wtforms import StringField, FloatField, SubmitField, SelectField
from wtforms.fields.html5 import DateField
from wtforms.validators import DataRequired, ValidationError


class EmployeeCreateForm(FlaskForm):
    name = StringField('Name', _name='name', validators=[DataRequired()])
    dob = DateField('Date of birth', _name='dob', format='%Y-%m-%d', validators=[DataRequired()])

    def validate_dob(self, field):
        if field.data <= datetime.today().date():
            return
        raise ValidationError('Date must be in the past')

    salary = FloatField('Salary', _name='salary', default=0.0)
    department = SelectField('Department', coerce=int)
    submit = SubmitField('Add')


class EmployeeEditForm(EmployeeCreateForm):
    submit = SubmitField('Edit')


class EmployeeSearchForm(FlaskForm):
    name = StringField('Name', _name='name', default='')
    date1 = DateField('Date of birth / From', _name='date1', format='%Y-%m-%d', default='')
    date2 = DateField('To', _name='date2', format='%Y-%m-%d', default='')
    department = SelectField('Department', coerce=str)
    submit = SubmitField('Search')

flaskr/departments/__init__.py
from . import views
from . import api

flaskr/departments/views.py
import requests

from flask import Blueprint, render_template, request, redirect, url_for, flash

from flaskr.departments.forms import DepartmentCreateForm, DepartmentEditForm

BASE_URL = 'https://dep-emp-app.herokuapp.com'
#BASE_URL = 'http://127.0.0.1:5000'

blueprint = Blueprint('departments', __name__)


@blueprint.route('/departments', methods=['GET', 'POST'])
def display_departments():
    """
    Takes all data from API
    :return: list of departments plus Create form
    """
    departments = requests.get(BASE_URL + '/api/departments/').json()
    employees = requests.get(BASE_URL + '/api/employees/').json()
    form = DepartmentCreateForm()
    if request.method == 'POST' and form.validate_on_submit():
        payload = {'name': request.form.get('name')}
        requests.post(BASE_URL + '/api/department/new', json=payload)
        flash('Department Created!', 'success')
        return redirect(url_for('departments.display_departments'))

    return render_template('departments.html', departments=departments, employees=employees, form=form)


@blueprint.route('/department/<_id>', methods=['GET', 'POST'])
def display_single_department(_id):
    """

    :param _id: id from DB
    :return:
    """
    req = requests.get(BASE_URL + '/api/department/' + _id)
    department = req.json()
    if req.status_code != 200:
        return department
    req_e = requests.get(BASE_URL + '/api/search/employees/?&department=' + str(department['id']))
    if req_e.status_code == 404:
        employees = req_e
    else:
        employees = req_e.json()
    form = DepartmentEditForm()
    if request.method == 'POST' and form.validate_on_submit():
        flash('Department Edited!', 'success')
        payload = {'name': request.form.get('name')}
        requests.put(BASE_URL + '/api/department/' + _id, json=payload)
        return redirect(url_for('departments.display_single_department', _id=_id))
        # maybe to make a redirect to a new object page

    return render_template('department.html', department=department, employees=employees, form=form)

flaskr/employees/__init__.py
from . import views
from . import api

flaskr/employees/views.py
import requests

from flask import Blueprint, render_template, request, redirect, url_for, flash

from flaskr.employees.forms import (EmployeeCreateForm,
                                    EmployeeEditForm, EmployeeSearchForm)
from werkzeug.datastructures import MultiDict

BASE_URL = 'https://dep-emp-app.herokuapp.com'

blueprint = Blueprint('employees', __name__)


@blueprint.route('/employees', methods=['GET', 'POST'])
def display_employees():
    employees = requests.get(BASE_URL + '/api/employees/').json()
    departments = requests.get(BASE_URL + '/api/departments/').json()
    filtered = []
    # search-form
    select_choices = [('', '--select field--'), (0, 'No department')] + [(dep['id'], dep['name']) for dep in
                                                                         departments]
    # set default values
    form = EmployeeSearchForm()
    form.department.choices = select_choices

    if request.method == 'POST':
        request_url = BASE_URL + '/api/search/employees/?'
        if request.form.get('name'):
            request_url += 'name=' + request.form.get('name')
        if request.form.get('date1'):
            request_url += '&date1=' + request.form.get('date1')
        if request.form.get('date2'):
            request_url += '&date2=' + request.form.get('date2')
        if request.form.get('department'):
            request_url += '&department=' + request.form.get('department')
        response = requests.get(request_url)
        if response.status_code != 404 and hasattr(response, "__iter__"):
            filtered = response.json()
        else:
            filtered = response
    return render_template('employees.html', employees=employees, filtered=filtered, form=form, departments=departments)


# SINGLE
@blueprint.route('/employee/<_id>', methods=['GET', 'POST'])
def display_single_employee(_id):
    req = requests.get(BASE_URL + '/api/employee/' + _id)
    employee = req.json()
    if req.status_code == 404:
        return employee
    employee = req.json()
    departments = requests.get(BASE_URL + '/api/departments/').json()
    select_choices = [(0, 'Not chosen')] + [(dep['id'], dep['name']) for dep in departments]

    # set default values
    form = EmployeeEditForm(formdata=MultiDict(employee))
    form.department.choices = select_choices
    # default for select field
    form.department.data = employee['department_id'] if employee['department_id'] else 0
    # EDIT-FORM
    if request.method == 'POST' and form.validate_on_submit():
        flash('Employee updated', 'success')
        department_id = request.form.get('department')
        payload = {'name': request.form.get('name'),
                   'salary': request.form.get('salary'),
                   'dob': request.form.get('dob'),
                   'department_id': None if department_id == '0' else department_id}

        requests.put(BASE_URL + '/api/employee/' + _id, json=payload)
        return redirect(url_for('employees.display_employees'))
    elif request.method != 'GET':
        for error in form.errors.values():
            flash(error[0], 'danger')

    return render_template('employee.html', employee=employee, form=form, departments=departments)


@blueprint.route('/new/employee/', methods=['GET', 'POST'])
def create_employee():
    employees = requests.get(BASE_URL + '/api/employees/').json()
    departments = requests.get(BASE_URL + '/api/departments/').json()
    # form-create
    form = EmployeeCreateForm()
    select_choices = [(0, 'Not chosen')] + [(dep['id'], dep['name']) for dep in departments]
    form.department.choices = select_choices
    if request.method == 'POST' and form.validate_on_submit():
        flash('Employee created!', 'success')
        department_id = request.form.get('department')
        payload = {'name': request.form.get('name'),
                   'salary': request.form.get('salary'),
                   'dob': request.form.get('dob'),
                   'department_id': None if department_id == '0' else department_id}

        requests.post(BASE_URL + '/api/employee/new', json=payload)
        return redirect(url_for('employees.display_employees'))
    elif request.method != 'GET':
        for error in form.errors.values():
            flash(error[0], 'danger')

    return render_template('create_employee.html', employees=employees, departments=departments, form=form)

flaskr/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='main.css') }}">
    {% block styles %}
    {% endblock %}

    <title>Shark</title>

</head>
<body>
    <header>
        <nav class="custom-nav navbar navbar-expand-lg navbar-light ">
            <img alt="logo" class="shark-image logo" src="{{ url_for('static', filename='shark.jpg') }}">
              <a class="navbar-brand" href="{{ url_for('home.home') }}">Shark Shipping Company</a>
              <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
              </button>
              <div class="collapse navbar-collapse" id="navbarNav">
                <ul class="navbar-nav">

                  <li class=" ml-3 nav-item">
                    <a class="nav-link" href="{{ url_for('departments.display_departments') }}">Departments</a>
                  </li>
                  <li class="ml-3 nav-item">
                    <a class="nav-link" href="{{ url_for('employees.display_employees') }}">Employees</a>
                  </li>
                    {% if not g.home %}
                          <li class="ml-4 nav-item">
                                  <a class="btn btn-info btn-lg" href="/api{{ request.path }}">SHOW API</a>
                          </li>
                    {% endif %}
                </ul>
              </div>
        </nav>
    </header>

    {% with messages = get_flashed_messages(with_categories=true) %}
        {% if messages %}
            {% for category, message in messages %}
                <div class="alert alert-{{ category }}">
                    {{ message }}
                </div>
            {% endfor %}
        {% endif %}
    {% endwith %}

    <div>
        {% block content %}
        {% endblock %}
        {% block error %}
        {% endblock %}
    </div>
    <footer id="footer">
        <div class="social-footer">
            <div class="address">
                <h4>Find us here:</h4>
                <p>2722  Elliot Avenue, Seattle WA Washington</p>
                <p>Phone: 206-510-8519</p>
                <p>Phone: 206-818-4903</p>
            </div>
            <div class="footer-media">
                <h4>Social Media</h4>
                <a href="#" class="btn fa fa-facebook"></a>
                <a href="#" class="btn fa fa-twitter"></a>
            </div>
        </div>

    </footer>

{% block scripts %}
{% endblock %}

    </body>
</html>

flaskr/templates/create_employee.html
{% extends 'base.html' %}
{% block content %}
    <div>

    </div>
    <div class="create-form">
        <h1>Create a new Employee</h1>
        <form action="" method="post" id="create-f">

            {{ form.csrf_token }}
                {{ form.name.label(class='form-control-label') }}
                {{ form.name(class='form-control form-control-sm') }}
                {{ form.department.label(class='form-control-label') }}
                {{ form.department(class='form-control form-control-sm') }}
                {{ form.dob.label(class='form-control-label') }}
                {{ form.dob(class='form-control form-control-sm', id='picker') }}
                {{ form.salary.label(class='form-control-label') }}
                {{ form.salary(class='form-control form-control-sm mb-2') }}
                {{ form.submit(class="btn btn-primary") }}

                <input class="btn btn-danger" type="reset" onclick="reset_form()" value="Clear">
        </form>
        <script>
            var today = new Date().toISOString().split('T')[0];
            document.getElementById("picker").setAttribute('max', today);
            function reset_form() {
                document.getElementById('search-f').reset();
            }
        </script>
    </div>
{% endblock %}

flaskr/templates/department.html
{% extends 'base.html' %}

{% block content %}
    {% if department %}
        <div class="single-department">
            <h1>{{ department.name }} </h1>
            <h2>Average salary is: {{ department.average_salary }} </h2>
        </div>

        <div class="create-form">
            <form action="" method="POST">
                {{ form.csrf_token }}
                {{ form.name.label(class='mt-3 form-control-label') }}
                {{ form.name(class='mb-3 form-control form-control-sm') }}
                {{ form.submit(class="btn btn-primary")}}
            </form>
            <div class="delete-btn">
                <button class="btn btn-danger">DELETE</button>
            </div>
        </div>

        <div class="members">
            <table>
                <tr>
                    <th>Name</th>
                    <th>Salary</th>
                </tr>
                {% for employee in employees %}
                <tr>
                    <td><a href="{{ url_for('employees.display_single_employee', _id=employee.id) }}">{{ employee.name }}</a></td>
                    <td>{{ employee.salary }}</td>
                    <td></td>
                </tr>
                {% endfor %}
            </table>
        </div>
    {% else %}
        <h2>Not found</h2>
    {% endif %}

{% endblock %}

{% block scripts %}
    <script src="{{ url_for('static', filename='script.js') }}"></script>
{% endblock %}

flaskr/templates/departments.html
{% extends 'base.html' %}
{% block content %}

    <section>
        <div class="create">
            <h2 class="create-head">Create new department</h2>
            <form action="" method="post" id="create-f">
                {{ form.csrf_token }}
                {{ form.name.label(class='mb-3 form-control-label') }}
                {{ form.name(class='mb-3 form-control form-control-sm') }}
                {{ form.submit(class="btn btn-primary")  }}
                <input class="btn btn-danger" type="reset" onclick="reset_form()" value="Clear">
            </form>
            <script>
                    function reset_form() {
                        document.getElementById('create-f').reset();
                    }
                </script>
        </div>
    </section>
    <section>
        <div class=" departments-table align-content-center">
            <h1>List of Departments</h1>
        <div class="table-custom">
            <table>
                <tr>
                    <th>Name</th>
                    <th>Average Salary</th>
                    <th>Number of Employees</th>
                </tr>
                {% for department in departments %}
                <tr>
                    <td id="empl-name"><a href="{{ url_for('departments.display_single_department', _id=department.id) }}">{{ department.name }}</a></td>
                    <td>{{ department.average_salary }}</td>
                    <td>{{ department.num_of_employees }}</td>

                </tr>
                {% endfor %}
            </table>
        </div>

        </div>
    </section>




{% endblock %}

flaskr/templates/employee.html
{% extends 'base.html' %}

{% block content %}
    {% if employee %}
        <div class="create-form">
            <h1>{{ employee.name }}</h1>
            <h2>Born on: {{ employee.dob }}</h2>
            <h2>Salary: {{ employee.salary }}</h2>
            {% for department in departments %}
                {% if department.id == employee.department_id %}
                    <h2>Current Department: {{ department.name }}</h2>
                {% endif %}
            {% endfor %}

            <form action="" method="post">
                {{ form.csrf_token }}
                    {{ form.name.label(class='form-control-label') }}
                    {{ form.name(class='form-control form-control-sm') }}
                    {{ form.department.label(class='form-control-label') }}
                    {{ form.department(class='form-control form-control-sm') }}
                    {{ form.dob.label(class='form-control-label') }}
                    {{ form.dob(class='form-control form-control-sm', id='picker') }}
                    {{ form.salary.label(class='form-control-label') }}
                    {{ form.salary(class='form-control form-control-sm mb-2') }}

                <div class="btn-submit">
                    {{ form.submit(class="btn btn-primary mb-2") }}
                </div>
            </form>
            <script>
                var today = new Date().toISOString().split('T')[0];
                document.getElementById("picker").setAttribute('max', today);
            </script>

            <div class="delete-btn">
                <button class="btn btn-danger">DELETE</button>
            </div>
        </div>
    {% else %}
        <h2>Not found</h2>
    {% endif %}
{% endblock %}

{% block scripts %}
    <script src="{{ url_for('static', filename='script.js') }}"></script>
{% endblock %}

flaskr/templates/employees.html
{% extends 'base.html' %}

{% block content %}
    <section>
        <div class="left-50">
            <div>
            <h2><a class="btn-lg bg-info" href="{{ url_for('employees.create_employee') }}">Create New Employee</a></h2>
            </div>

            <div class="display-list">
                <table>
                    <tr>
                        <th>Name</th>
                        <th>Salary</th>
                        <th>Date Of Birth</th>
                        <th>Department</th>
                    </tr>
                    {% for employee in employees %}
                    <tr>
                        <td class="text-left"><a href="{{ url_for('employees.display_single_employee', _id=employee.id) }}">{{ employee.name }}</a></td>
                        <td>{{ employee.salary }}</td>
                        <td>{{ employee.dob }}</td>
                        {% for department in departments %}
                            {% if department.id == employee.department_id %}
                                <td>{{ department.name }}</td>
                            {% endif %}
                        {% endfor %}

                    </tr>
                    {% endfor %}
                </table>
            </div>

        </div>
    </section>

    <section>
        <div class="left-50">
            <div class="search-form">
                <form action="" method="post" id="search-f">
                    {{ form.csrf_token }}
                    {{ form.name.label(class='mb-3 form-control-label') }}
                    {{ form.name(class='mb-3 form-control form-control-sm') }}
                    {{ form.date1.label(class=' mb-3 form-control-label') }}
                    {{ form.date1(class='mb-3 form-control picker', id='date1')}}

                    {{ form.date2.label(class=' mb-3 form-control-label') }}
                    {{ form.date2(class='mb-3 form-control picker', id='date2') }}

                    {{ form.department.label(class='form-control-label') }}
                    {{ form.department(class='mb-3 form-control form-control-sm') }}
                    {{ form.submit(class="btn btn-primary") }}
                    <input class="btn btn-danger" type="reset" onclick="reset_form()" value="Clear">
                </form>
            </div>
            <div class="search-result">
            <h2>Search results</h2>
                {% if filtered %}
                    <ul class="unordered-default">
                        {% for employee in filtered %}
                            <li><a href="{{ url_for('employees.display_single_employee', _id=employee.id) }}" >{{ employee.name }}</a></li>
                        {% endfor %}
                    </ul>
                {% else %}
                    <h2>Not found</h2>
                {% endif %}
            </div>
        </div>
    </section>
{% endblock %}
{% block scripts %}
    <script src="{{ url_for('static', filename='employee-search.js') }}"></script>
{% endblock %}

flaskr/templates/home.html
{% extends 'base.html' %}
{% block styles %}
    <link type="text/css" rel="stylesheet" href="{{ url_for('static', filename='home.css') }}">
{% endblock %}


{% block content %}
    <div class="stats-block">
        <h2 class="statistic">Company facts</h2>
        <div class="stats-single">
            <div class=" counter stats-number">
                <span id="departments"></span>
            </div>
            <div class="stats-text">Departments</div>
        </div>
        <div class="stats-single">
            <div class=" counter stats-number">
                <span id="employees"></span>
            </div>
            <div class="stats-text">Employees</div>
        </div>
        <div class="stats-single">
            <div class=" counter stats-number">
                <span id="salaries"></span>
            </div>
            <div class="stats-text">Average Salary</div>
        </div>

    </div>

{% endblock %}
{% block scripts %}
    <script src="{{ url_for('static', filename='home-script.js') }}"></script>
{% endblock %}